function [probCEQ]=probCEQ(U);

g=U(1,1);
n=U(1,2);
a=U(1,3);
vlow=U(1,4);
vup=U(1,5);
x=U(1,6);
b=U(1,7);
chi=U(1,8);
lambda=U(1,9);

cpi1=1.1952;
cpi2=1;
cpi3=1.3887;
cpi4=1.2944;

% % Kagel and Levin: First-Price
% % ----------------------------
if g==1;
bethainv=b+a/2+chi*(-a/2+a/n);
    if bethainv<=x-a;
    EP=0;
        else;
        if bethainv<=x;
        EP=(1/n)*((1-(x-bethainv)/a)^n)*((1-chi)*(x-a/2+a/(n+1)...
                 -(x-bethainv)/(n+1))+chi*x-b);

        else;
            if bethainv<=x+a;
    EP=(1/a)*((1-chi)*(bethainv^2/2-(a/2-a/n)*(bethainv-x)...
              -(x+a/2)*(a/n)*((bethainv-x)/a)^n...
              -(bethainv-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2)...
              +(chi*x-b)*(bethainv-x-(a/n)*((bethainv-x)/a)^n))...
              +(1/n)*((1-chi)*(x-a/2+a/(n+1))+chi*x-b);
            else;
    EP=x-b;
            end;
        end;
    end;

% % Denominator of the logit:
if max(x-a/2,vlow)==x-a/2 & min(x+a/2,vup)==x+a/2;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+a/2+chi*(-a/2+a/n);
for i=2:(a*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)+a/2+chi*(-a/2+a/n);
end;
for i=1:(a*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1))+chi*x-b(i,1));
        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2) ...
              +(chi*x-b(i,1))*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*((1-chi)*(x-a/2+a/(n+1))+chi*x-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
else;
    if max(x-a/2,vlow)==vlow & min(x+a/2,vup)==x+a/2;
b(1,1)=vlow;
bethainv(1,1)=b(1,1)+a/2+chi*(-a/2+a/n);
for i=2:((x+a/2-vlow)*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)+a/2+chi*(-a/2+a/n);
end;
for i=1:((x+a/2-vlow)*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1))+chi*x-b(i,1));
        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2) ...
              +(chi*x-b(i,1))*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*((1-chi)*(x-a/2+a/(n+1))+chi*x-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
    else;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+a/2+chi*(-a/2+a/n);
for i=2:((vup-x+a/2)*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)+a/2+chi*(-a/2+a/n);
end;
for i=1:((vup-x+a/2)*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1))+chi*x-b(i,1));
        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2) ...
              +(chi*x-b(i,1))*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*((1-chi)*(x-a/2+a/(n+1))+chi*x-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
    end;
end;
Q=sum(q);
probCEQ=exp((1/cpi1)*lambda*EP)/Q;
else;

% % Kagel and Levin: Second-Price
% % -----------------------------
if g==2;
bethainv=b-(1-chi)*(-a/2+a/n);
bethadown=x+(1-chi)*(-a/2+a/n);
bethaup=x+a+(1-chi)*(-a/2+a/n);
    if bethainv<=x-a;
EP=0;
    else;
    if bethainv<=x;
EP=(1/n)*((1-(x-bethainv)/a)^n)*((1-chi)*(x-a/2+a/n...
          -(x-bethainv)/n)+chi*x-b-((1-chi-n)/n)*(a/(n+1))*(1-(x-bethainv)/a));
    else;
        if bethainv<=x+a;
EP=(1/a)*((1-chi)*(bethainv^2/2-x^2/2-(a/2-a/n)*(bethainv-x)...
           -(x+a/2)*(a/n)*((bethainv-x)/a)^n...
           -((bethainv-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(b-chi*x)*(bethainv-(a/n)*((bethainv-x)/a)^n)...
           +bethainv^2/2-x^2/2-(a^2/(n*(n+1)))*((bethainv-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        else;
EP=(1/a)*((1-chi)*((x+a)^2/2-x^2/2-(a/2-a/n)*(x+a-x)...
           -(x+a/2)*(a/n)*((x+a-x)/a)^n...
           -((x+a-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(bethaup-chi*x)*(x+a-(a/n)*((x+a-x)/a)^n)...
           +(x+a)^2/2-x^2/2-(a^2/(n*(n+1)))*((x+a-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        end;
    end;
    end; 

% % Denominator of the logit:
if max(x-a/2,vlow)==x-a/2 & min(x+a/2,vup)==x+a/2;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)-(1-chi)*(-a/2+a/n);
for i=2:(a*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)-(1-chi)*(-a/2+a/n);
end;
for i=1:(a*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/n...
          -(x-bethainv(i,1))/n)+chi*x-b(i,1)-((1-chi-n)/n)*(a/(n+1))*(1-(x-bethainv(i,1))/a));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-x^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(b(i,1)-chi*x)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           +bethainv(i,1)^2/2-x^2/2-(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        else;
EPT(i,1)=(1/a)*((1-chi)*((x+a)^2/2-x^2/2-(a/2-a/n)*(x+a-x)...
           -(x+a/2)*(a/n)*((x+a-x)/a)^n...
           -((x+a-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(bethaup-chi*x)*(x+a-(a/n)*((x+a-x)/a)^n)...
           +(x+a)^2/2-x^2/2-(a^2/(n*(n+1)))*((x+a-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        end;
    end;
    end; 
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
else;
    if max(x-a/2,vlow)==vlow & min(x+a/2,vup)==x+a/2;
b(1,1)=vlow;
bethainv(1,1)=b(1,1)-(1-chi)*(-a/2+a/n);
for i=2:((x+a/2-vlow)*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)-(1-chi)*(-a/2+a/n);
end;
for i=1:((x+a/2-vlow)*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/n...
          -(x-bethainv(i,1))/n)+chi*x-b(i,1)-((1-chi-n)/n)*(a/(n+1))*(1-(x-bethainv(i,1))/a));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-x^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(b(i,1)-chi*x)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           +bethainv(i,1)^2/2-x^2/2-(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        else;
EPT(i,1)=(1/a)*((1-chi)*((x+a)^2/2-x^2/2-(a/2-a/n)*(x+a-x)...
           -(x+a/2)*(a/n)*((x+a-x)/a)^n...
           -((x+a-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(bethaup-chi*x)*(x+a-(a/n)*((x+a-x)/a)^n)...
           +(x+a)^2/2-x^2/2-(a^2/(n*(n+1)))*((x+a-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        end;
    end;
    end; 
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
    else;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)-(1-chi)*(-a/2+a/n);
for i=2:((vup-x+a/2)*100+1);
    b(i,1)=b(i-1)+.01;
    bethainv(i,1)=b(i,1)-(1-chi)*(-a/2+a/n);
end;
for i=1:((vup-x+a/2)*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*((1-chi)*(x-a/2+a/n...
          -(x-bethainv(i,1))/n)+chi*x-b(i,1)-((1-chi-n)/n)*(a/(n+1))*(1-(x-bethainv(i,1))/a));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*((1-chi)*(bethainv(i,1)^2/2-x^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(b(i,1)-chi*x)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           +bethainv(i,1)^2/2-x^2/2-(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        else;
EPT(i,1)=(1/a)*((1-chi)*((x+a)^2/2-x^2/2-(a/2-a/n)*(x+a-x)...
           -(x+a/2)*(a/n)*((x+a-x)/a)^n...
           -((x+a-x)^(n+1))/(n*(n+1)*a^(n-1)))...
           -(bethaup-chi*x)*(x+a-(a/n)*((x+a-x)/a)^n)...
           +(x+a)^2/2-x^2/2-(a^2/(n*(n+1)))*((x+a-x)/a)^(n+1)+(bethadown-chi*x)*x)...
           +(1/n)*((1-chi)*(x-a/2+a/n)+chi*x-bethadown-((1-chi-n)/n)*(a/(n+1)));
        end;
    end;
    end; 
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
    end;
end;
Q=sum(q);
probCEQ=exp((1/cpi2)*lambda*EP)/Q;
else;

% % Avery and Kagel: First-Price (No Data Obtained)
% % -----------------------------------------------
if g==3;
bethainv=(b-chi/4)*(1/(1/2-chi/4));
    if bethainv<=0;
    EP=0;
    else;
        if bethainv<=1;
    EP=bethainv*((1-chi)*(x/2+bethainv/2)+chi*(x/2+1/4)-b)-(1-chi)/2*bethainv^2/2;
        else;
    EP=(1-chi)*(x/2+1/2)+chi*(x/2+1/4)-b-(1-chi)/4;
        end;
    end;

% % Denominator of the logit:
b(1,1)=0;
bethainv(1,1)=(b(1,1)-chi/4)*(1/(1/2-chi/4));
for i=2:101;
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=(b(i,1)-chi/4)*(1/(1/2-chi/4));
end;
for i=1:101;
    if bethainv(i,1)<=0;
    EPT(i,1)=0;
    else;
        if bethainv(i,1)<=1;
    EPT(i,1)=bethainv(i,1)*((1-chi)*(x/2+bethainv(i,1)/2)+chi*(x/2+1/4)-b(i,1))-(1-chi)/2*bethainv(i,1)^2/2;
        else;
    EPT(i,1)=(1-chi)*(x/2+1/2)+chi*(x/2+1/4)-b(i,1)-(1-chi)/4;
        end;
    end;
q(i,1)=exp((1/cpi3)*lambda*EPT(i,1));
end;
Q=sum(q);
probCEQ=exp((1/cpi3)*lambda*EP)/Q;
else;

% % Avery and Kagel: Second-Price
% % -----------------------------
bethainv=(b-chi*5/2)*(1/(2-chi));
bethaup=4*(2-chi)+chi*5/2;
    if bethainv<=1;
    EP=0;
    else;
        if bethainv<=4;
    EP=((bethainv-1)/3)*((1-chi)*(x+bethainv)+chi*(x+5/2)-b)...
        -((1-chi)-(2-chi))*(3/2)*((bethainv-1)/3)^2;
        else;
    EP=(1-chi)*(x+4)+chi*(x+5/2)-bethaup-((1-chi)-(2-chi))*(3/2);
        end;
    end;

% %Denominator of the logit:
b(1,1)=2;
bethainv(1,1)=(b(1,1)-chi*5/2)*(1/(2-chi));
for i=2:601;
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=(b(i,1)-chi*5/2)*(1/(2-chi));
end;
for i=1:601;
    if bethainv(i,1)<=1;
    EPT(i,1)=0;
    else;
        if bethainv(i,1)<=4;
    EPT(i,1)=((bethainv(i,1)-1)/3)*((1-chi)*(x+bethainv(i,1))+chi*(x+5/2)-b(i,1))...
        -((1-chi)-(2-chi))*(3/2)*((bethainv(i,1)-1)/3)^2;
        else;
    EPT(i,1)=(1-chi)*(x+4)+chi*(x+5/2)-bethaup-((1-chi)-(2-chi))*(3/2);
        end;
    end;
q(i,1)=exp((1/cpi4)*lambda*EPT(i,1));
end;
Q=sum(q);
probCEQ=exp((1/cpi4)*lambda*EP)/Q;
        end;
    end;
end;