function [LL]=LLAuction1CURSED(U2);

% % (Comment the specification you do not want to use)

Data=DataKLF5;

% % SPECIFICATION: ONE PRECISION
% % ----------------------------

% % Unknown parameters:
alpha1=U2(1,1);
chi1=U2(2,1);
chi2=U2(3,1);
lambda=U2(4,1);

Likelihood=ones(251,1);

% % Define the Likelihood of observing each bid for each signal:
for j=[1 6 11 16 21 26 31 36 41 46 51 56 61 66 71 76 81 86 91 96 101 106 111 116 121 126 131 136 141 146 151 156 161 166 171 176 181 186 191 196 201 206 211 216 221 226 231 236 241 246 251];
for i=1:5;
prob1(i,1)=probCEQ([Data(j+i-1,:) chi1 lambda]);
prob2(i,1)=probCEQ([Data(j+i-1,:) chi2 lambda]);
end;
Likelihood(j,1)=alpha1*prod(prob1)+(1-alpha1)*(prod(prob2));
LogLikelihood(j,1)=log(Likelihood(j,1));
end;
Likelihood;
LogLikelihood;
LL=-sum(LogLikelihood);

% % SPECIFICATION: TYPE-SPECIFIC PRECISION
% % --------------------------------------

% % Unknown parameters:
alpha1=U2(1,1);
chi1=U2(2,1);
chi2=U2(3,1);
lambda1=U2(4,1);
lambda2=U2(5,1);

Likelihood=ones(251,1);

% % Define the Likelihood of observing each bid for each signal:
for j=1:5:251;
for i=1:5;
prob1(i,1)=probCEQ([Data(j+i-1,:) chi1 lambda1]);
prob2(i,1)=probCEQ([Data(j+i-1,:) chi2 lambda2]);
prob3(i,1)=probCEQ([Data(j+i-1,:) chi3 lambda3]);
end;
Likelihood(j,1)=alpha1*prod(prob1)+alpha2*(prod(prob2))+(1-alpha1-alpha2)*(prod(prob3));
LogLikelihood(j,1)=log(Likelihood(j,1));
end;
Likelihood;
LogLikelihood;
LL=-sum(LogLikelihood);