function [probRL1]=probRL1ipv(U);

g=U(1,1);
n=U(1,2);
x=U(1,3);
b=U(1,4);
lambda=U(1,5);

cpi1=1.4508;

% % Goeree, Holt and Palfrey
% % ------------------------
if g==1;
bset=[0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11];           
probset=[1/24; 1/12+1/24; 2/12+1/24; 3/12+1/24; 4/12+1/24; 5/12+1/24; 6/12+1/24; 7/12+1/24; 8/12+1/24; 9/12+1/24; 10/12+1/24; 11/12+1/24];

prob=0;
for i=1:12;
    if b==bset(i,1);
    prob=probset(i,1);
    else;
    prob=prob;
    end;
end;

EP=(x-b)*prob;

% % Denominator of the logit:
for i=1:12;
EPT(i,1)=(x-bset(i,1))*probset(i,1);
q(i,1)=exp((1/cpi1)*(1/2)*lambda*EPT(i,1));
end;
Q=sum(q);
probRL1=exp((1/cpi1)*(1/2)*lambda*EP)/Q;

else;
    
bset=[0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12];           
probset=[1/26; 1/13+1/26; 2/13+1/26; 3/13+1/26; 4/13+1/26; 5/13+1/26; 6/13+1/26; 7/13+1/26; 8/13+1/26; 9/13+1/26; 10/13+1/26; 11/13+1/26; 12/13+1/26];

prob=0;
for i=1:13;
    if b==bset(i,1);
    prob=probset(i,1);
    else;
    prob=prob;
    end;
end;

EP=(x-b)*prob;

% % Denominator of the logit:
for i=1:13;
EPT(i,1)=(x-bset(i,1))*probset(i,1);
q(i,1)=exp((1/cpi1)*(1/2)*lambda*EPT(i,1));
end;
Q=sum(q);
probRL1=exp((1/cpi1)*(1/2)*lambda*EP)/Q;
end;