function [probTL1]=probTL1ipv(U);

g=U(1,1);
n=U(1,2);
x=U(1,3);
b=U(1,4);
lambda=U(1,5);

cpi1=1.4508;

% % Goeree, Holt and Palfrey
% % ------------------------
if g==1;
bset=[0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11];           
probset=[1/12; 1/6; 1/6+1/12; 2/6; 2/6+1/12; 3/6; 3/6+1/12; 4/6; 4/6+1/12; 5/6; 5/6; 5/6+1/12];

prob=0;
for i=1:12;
    if b==bset(i,1);
    prob=probset(i,1);
    else;
    prob=prob;
    end;
end;

EP=(x-b)*prob;

% % Denominator of the logit:
for i=1:12;
EPT(i,1)=(x-bset(i,1))*probset(i,1);
q(i,1)=exp((1/cpi1)*(1/2)*lambda*EPT(i,1));
end;
Q=sum(q);
probTL1=exp((1/cpi1)*(1/2)*lambda*EP)/Q;

else;
    
bset=[0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12];           
probset=[1/12; 1/6; 1/6; 1/6+1/12; 2/6; 2/6+1/12; 3/6; 3/6+1/12; 4/6; 4/6+1/12; 5/6; 5/6; 5/6+1/12];

prob=0;
for i=1:13;
    if b==bset(i,1);
    prob=probset(i,1);
    else;
    prob=prob;
    end;
end;

EP=(x-b)*prob;

% % Denominator of the logit:
for i=1:13;
EPT(i,1)=(x-bset(i,1))*probset(i,1);
q(i,1)=exp((1/cpi1)*(1/2)*lambda*EPT(i,1));
end;
Q=sum(q);
probTL1=exp((1/cpi1)*(1/2)*lambda*EP)/Q;
end;