function [probTL2]=probTL2(U);

g=U(1,1);
n=U(1,2);
a=U(1,3);
vlow=U(1,4);
vup=U(1,5);
x=U(1,6);
b=U(1,7);
lambda=U(1,8);

cpi1=1.1952;
cpi2=1;
cpi3=1.3887;
cpi4=1.2944;

% % Kagel and Levin: First-Price
% % ----------------------------
if g==1;
bethainv=b+a/2;
    if bethainv<=x-a;
    EP=0;
        else;
        if bethainv<=x;
        EP=(1/n)*((1-(x-bethainv)/a)^n)*(x-a/2+a/(n+1)...
                 -(x-bethainv)/(n+1)-b);
        else;
            if bethainv<=x+a;
    EP=(1/a)*(bethainv^2/2-(a/2-a/n)*(bethainv-x)...
              -(x+a/2)*(a/n)*((bethainv-x)/a)^n...
              -(bethainv-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2 ...
              -b*(bethainv-x-(a/n)*((bethainv-x)/a)^n))...
              +(1/n)*(x-a/2+a/(n+1)-b);
            else;
    EP=x-b;
            end;
        end;
    end;

% % Denominator of the logit:
if max(x-a/2,vlow)==x-a/2 & min(x+a/2,vup)==x+a/2;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+a/2;
for i=2:(a*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+a/2;
end;
for i=1:(a*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1)-b(i,1));

        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2 ...
              -b(i,1)*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*(x-a/2+a/(n+1)-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
else;
    if max(x-a/2,vlow)==vlow & min(x+a/2,vup)==x+a/2;
b(1,1)=vlow;
bethainv(1,1)=b(1,1)+a/2;
for i=2:((x+a/2-vlow)*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+a/2;
end;
for i=1:((x+a/2-vlow)*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1)-b(i,1));

        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2 ...
              -b(i,1)*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*(x-a/2+a/(n+1)-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
    else;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+a/2;
for i=2:((vup-x+a/2)*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+a/2;
end;
for i=1:((vup-x+a/2)*100+1);
    if bethainv(i,1)<=x-a;
    EPT(i,1)=0;
        else;
        if bethainv(i,1)<=x;
    EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+a/(n+1)...
             -(x-bethainv(i,1))/(n+1)-b(i,1));

        else;
            if bethainv(i,1)<=x+a;
    EPT(i,1)=(1/a)*(bethainv(i,1)^2/2-(a/2-a/n)*(bethainv(i,1)-x)...
              -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
              -(bethainv(i,1)-x)^(n+1)/(n*(n+1)*a^(n-1))-x^2/2 ...
              -b(i,1)*(bethainv(i,1)-x-(a/n)*((bethainv(i,1)-x)/a)^n))...
              +(1/n)*(x-a/2+a/(n+1)-b(i,1));
            else;
    EPT(i,1)=x-b(i,1);
            end;
        end;
    end;
q(i,1)=exp((1/cpi1)*lambda*EPT(i,1));
end;
    end;
end;
Q=sum(q);
probTL2=exp((1/cpi1)*lambda*EP)/Q;
else;

% % Kagel and Levin: Second-Price
% % -----------------------------
if g==2;
bethainv=b+(a/2)*((n-2)/(n-1));
bethadown=x-(a/2)*((n-2)/(n-1));
bethaup=x+a-(a/2)*((n-2)/(n-1));
    if bethainv<=x-a;
EP=0;
    else;
    if bethainv<=x;
EP=(1/n)*((1-(x-bethainv)/a)^n)*(x-a/2+(2*a)/(n+1)...
          -(x-bethainv)*(2/(n+1))-b);
    else;
        if bethainv<=x+a;
EP=(1/a)*(bethainv^2-(a/2-a/n)*(bethainv-x)...
           -(x+a/2)*(a/n)*((bethainv-x)/a)^n...
           -((bethainv-x)^(n+1))/(n*(n+1)*a^(n-1))...
           -b*(bethainv-(a/n)*((bethainv-x)/a)^n)...
           -(a^2/(n*(n+1)))*((bethainv-x)/a)^(n+1)-x^2+bethadown*x)...
           +(1/n)*(x-a/2+(2*a)/(n+1)-bethadown);
        else;
EP=(1/a)*(2*a*x+a^2/2-bethaup*(x+a*(n-1)/n)+bethadown*x)-bethadown/n;  
        end;
    end;
    end;    

% % Denominator of the logit:
if max(x-a/2,vlow)==x-a/2 & min(x+a/2,vup)==x+a/2;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+(a/2)*((n-2)/(n-1));
for i=2:(a*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+(a/2)*((n-2)/(n-1));
end;
for i=1:(a*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+(2*a)/(n+1)...
          -(x-bethainv(i,1))*(2/(n+1))-b(i,1));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*(bethainv(i,1)^2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1))...
           -b(i,1)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           -(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)-x^2+bethadown*x)...
           +(1/n)*(x-a/2+(2*a)/(n+1)-bethadown);
        else;
EPT(i,1)=(1/a)*(2*a*x+a^2/2-bethaup*(x+a*(n-1)/n)+bethadown*x)-bethadown/n;  
        end;
    end;
    end;    
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
else;
    if max(x-a/2,vlow)==vlow & min(x+a/2,vup)==x+a/2;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+(a/2)*((n-2)/(n-1));
for i=2:((x+a/2-vlow)*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+(a/2)*((n-2)/(n-1));
end;
for i=1:((x+a/2-vlow)*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+(2*a)/(n+1)...
          -(x-bethainv(i,1))*(2/(n+1))-b(i,1));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*(bethainv(i,1)^2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1))...
           -b(i,1)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           -(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)-x^2+bethadown*x)...
           +(1/n)*(x-a/2+(2*a)/(n+1)-bethadown);
        else;
EPT(i,1)=(1/a)*(2*a*x+a^2/2-bethaup*(x+a*(n-1)/n)+bethadown*x)-bethadown/n;  
        end;
    end;
    end;    
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
    else;
b(1,1)=x-a/2;
bethainv(1,1)=b(1,1)+(a/2)*((n-2)/(n-1));
for i=2:((vup-x+a/2)*100+1);
    b(i,1)=b(i-1,1)+.01;
    bethainv(i,1)=b(i,1)+(a/2)*((n-2)/(n-1));
end;
for i=1:((vup-x+a/2)*100+1);
    if bethainv(i,1)<=x-a;
EPT(i,1)=0;
    else;
    if bethainv(i,1)<=x;
EPT(i,1)=(1/n)*((1-(x-bethainv(i,1))/a)^n)*(x-a/2+(2*a)/(n+1)...
          -(x-bethainv(i,1))*(2/(n+1))-b(i,1));
    else;
        if bethainv(i,1)<=x+a;
EPT(i,1)=(1/a)*(bethainv(i,1)^2-(a/2-a/n)*(bethainv(i,1)-x)...
           -(x+a/2)*(a/n)*((bethainv(i,1)-x)/a)^n...
           -((bethainv(i,1)-x)^(n+1))/(n*(n+1)*a^(n-1))...
           -b(i,1)*(bethainv(i,1)-(a/n)*((bethainv(i,1)-x)/a)^n)...
           -(a^2/(n*(n+1)))*((bethainv(i,1)-x)/a)^(n+1)-x^2+bethadown*x)...
           +(1/n)*(x-a/2+(2*a)/(n+1)-bethadown);
        else;
EPT(i,1)=(1/a)*(2*a*x+a^2/2-bethaup*(x+a*(n-1)/n)+bethadown*x)-bethadown/n;  
        end;
    end;
    end;    
q(i,1)=exp((1/cpi2)*lambda*EPT(i,1));
end;
    end;
end;

Q=sum(q);
probTL2=exp((1/cpi2)*lambda*EP)/Q;
else;

% % Avery and Kagel: First-Price (No Data Obtained)
% % -----------------------------------------------
if g==3;
    if b<=1/3;
    EP=(x/2-b/4)*(3*b);
    else;
    EP=(x/2+1/2-b-1/4);
    end;

% % Denominator of the logit:
b(1,1)=0;
for i=2:101;
    b(i,1)=b(i-1,1)+.01;
end;
for i=1:101;
    if b(i,1)<=1/3;
    EPT(i,1)=(x/2-b(i,1)/4)*(3*b(i,1));
    else;
    EPT(i,1)=(x/2+1/2-b(i,1)-1/4);
    end;
q(i,1)=exp((1/cpi3)*lambda*EPT(i,1));
end;
Q=sum(q);
probTL2=exp((1/cpi3)*lambda*EP)/Q;
else;

% % Avery and Kagel: Second-Price
% % -----------------------------
if b<=3.49;
   EP=0;
   else;
   if b==3.5;
   EP=(1/4)*(x+7/4-3.5);
      else;
      if b<=6.49;
      EP=(1/2)*(x+7/4-3.5);
         else;
         if b==6.5;
         EP=(1/2)*(x+7/4-3.5)+(1/4)*(x+13/4-6.5);
         else;
         EP=(1/2)*(x+7/4-3.5)+(1/2)*(x+13/4-6.5);
         end;
      end;
   end;
end;

% % Denominator of the logit:
b(1,1)=2;
for i=2:601;
    b(i,1)=b(i-1,1)+.01;
end;
for i=1:601;
if b(i,1)<=3.49;
   EPT(i,1)=0;
   else;
   if b(i,1)==3.5;
   EPT(i,1)=(1/4)*(x+7/4-3.5);
      else;
      if b(i,1)<=6.49;
      EPT(i,1)=(1/2)*(x+7/4-3.5);
         else;
         if b(i,1)==6.5;
         EPT(i,1)=(1/2)*(x+7/4-3.5)+(1/4)*(x+13/4-6.5);
         else;
         EPT(i,1)=(1/2)*(x+7/4-3.5)+(1/2)*(x+13/4-6.5);
         end;
      end;
   end;
end;
q(i,1)=exp((1/cpi4)*lambda*EPT(i,1));
end;
Q=sum(q);
probTL2=exp((1/cpi4)*lambda*EP)/Q;
end;
end;
end;